varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float mixturePercent;

vec4 getscreencolor(vec4 base, vec4 overlay) {
    vec4 one = vec4(1.0);
    vec4 rtn = one - (one - base) * (one - overlay);
    return rtn;
}

vec3 rgbToHsv(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsvToRgb(vec3 c) {
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main() {
    vec4 c1 = texture2D(inputImageTexture, textureCoordinate);
    vec4 c2 = texture2D(inputImageTexture2, textureCoordinate);
    c1.a=min(c1.a,0.5);
    float maxv = max(rgbToHsv(c1.rgb).b, rgbToHsv(c2.rgb).b);
    vec4 usec = getscreencolor(c1, c2);
    vec3 hsv = rgbToHsv(usec.rgb);
    if (hsv.b > maxv) {
        hsv.b = maxv;
        usec.rgb = hsvToRgb(hsv);
    }
    gl_FragColor = usec;
}



