precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
vec2 pos;

//高亮 GPUImageHighlightFilter
vec3 luminanceWeighting = vec3(0.32);
vec4 getHighLight2(vec4 source) {
    bool change = progress > 0.0;
    float highlights = 1.0 - abs(progress / 200.1);
    float luminance = dot(source.rgb, luminanceWeighting);
    float highlight = clamp((1.0 - (pow(1.0 - luminance, 1.0 / (2.0 - highlights)) + (-0.1) * pow(1.0 - luminance, 2.0 / (2.0 - highlights)))) - luminance, -1.0, 0.0);
    vec3 result = ((luminance + highlight)) * ((source.rgb) / (luminance));
    vec3 cha = result.rgb - source.rgb;
    float xishu = 2.0;
    if (change) {
        result = source.rgb - cha * xishu;
    } else {
        result = source.rgb + cha * xishu;
    }

    vec4 rtn = vec4(result.rgb, source.a);
    return rtn;
}




void main() {
    pos = textureCoordinate / 1.0;
    vec4 color = texture2D(inputImageTexture, pos);
    color = getHighLight2(color);
    gl_FragColor = color;
}
