precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float ratio1;
highp vec2 center = vec2(0.5);
uniform float progress;
vec2 pos;

//暗角
vec4 getVignetting(vec4 source) {
    vec3 usecolor = progress >= 0.0 ? vec3(0.0) : vec3(1.0);
    //   点与中心的距离 0->1
    float length_center = distance(pos, center) * 2.0 / 1.42;
    //   进度 0->1
    float progress = abs(progress) / 50.0;

    //    把进度转化成一个圆的长度
    float minl = 1.0 - progress * 0.7;
    float mixvalue = length_center;
    float l = 0.5;
    if (mixvalue < minl) {
        mixvalue = 0.0;
    } else if (mixvalue > minl + l) {
        mixvalue = 1.0;
    } else {
        mixvalue = (mixvalue - minl) / l;
        mixvalue *= mixvalue;
    }
    //    mixvalue = mix(minl, minl + l, mixvalue);

    vec3 color = mix(source.rgb, usecolor, mixvalue);
    return vec4(color, source.a);
}



void main() {
    pos = textureCoordinate / 1.0;
    vec4 color = texture2D(inputImageTexture, pos);
    color = getVignetting(color);
    gl_FragColor = color;
//    gl_FragColor=vec4(.0,1.0,0.0,1.0);
}
