//https://www.shadertoy.com/view/MsGGzW
precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

vec4 getusecolor(vec2 pos){
    return texture2D(inputImageTexture, pos);
}

vec4 getblur(vec2 uv) {
    float offsize=0.02;
    float random = (0.5 - Rand(uv)) * offsize ;
    float random2 = (0.5 - Rand(uv / 2.0))  * offsize;
    uv += vec2(random, random2);
//    if(true){
//        return getusecolor(uv);
//    }
    vec2 size = vec2(0.002);
    if (ratio > 1.0) {
        size.y *= ratio;
    } else {
        size.x /= ratio;
    }
    vec4 usecolor;
    float tol = 0.0;
    {
        vec4 sum = vec4(0.0);
        sum += getusecolor(uv);

        sum += getusecolor(uv + vec2(size.x, size.y));
        sum += getusecolor(uv + vec2(-size.x, size.y));
        sum += getusecolor(uv + vec2(size.x, -size.y));
        sum += getusecolor(uv + vec2(-size.x, -size.y));

        sum += getusecolor(uv + vec2(0.0, -size.y));
        sum += getusecolor(uv + vec2(0.0, size.y));
        sum += getusecolor(uv + vec2(size.x, 0.0));
        sum += getusecolor(uv + vec2(-size.x, 0.0));
        tol += 9.0;

//        sum += getusecolor(uv + vec2(0.0, -size.y * 2.0));
//        sum += getusecolor(uv + vec2(size.x, -size.y * 2.0));
//        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y * 2.0));
//        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y * 2.0));
//        sum += getusecolor(uv + vec2(-size.x, -size.y * 2.0));
//
//        sum += getusecolor(uv + vec2(0.0, size.y * 2.0));
//        sum += getusecolor(uv + vec2(size.x, size.y * 2.0));
//        sum += getusecolor(uv + vec2(size.x * 2.0, size.y * 2.0));
//        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y * 2.0));
//        sum += getusecolor(uv + vec2(-size.x, size.y * 2.0));
//
//        sum += getusecolor(uv + vec2(size.x * 2.0, size.y));
//        sum += getusecolor(uv + vec2(size.x * 2.0, -size.y));
//        sum += getusecolor(uv + vec2(size.x * 2.0, 0.0));
//
//        sum += getusecolor(uv + vec2(-size.x * 2.0, size.y));
//        sum += getusecolor(uv + vec2(-size.x * 2.0, -size.y));
//        sum += getusecolor(uv + vec2(-size.x * 2.0, 0.0));
//        tol += 16.0;
        usecolor = vec4(sum / tol);
    }
    return usecolor;
}

void main() {
    vec4 color = getblur(textureCoordinate);
    gl_FragColor =color;
}