//https://www.shadertoy.com/view/wddGzj
precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;


const vec2 center = vec2(0.5);

float h21(vec2 p) {  return fract(sin(dot(p, vec2(27.3, 57.7))) * 1e4); }
float di(vec2 p) { p = abs(p); return (p.x + p.y - 1.) * .7 + .05; }
vec3 jigsaw(vec2 p) {
    // 本地单元格 ID 和坐标。
    vec2 ip = floor(p);
//    这里弄成统一的 -0.5-0.5;
    p -= (ip + .5);

    // Directional helper vectors.
    vec2 m = fract(ip / 2.) * 2. - .5; // Orientation vector.
    vec2 dirV = dot(m, p) < 0. ? -m : m; // Direction vector.
    vec2 rD = (h21(ip) - .5) * dirV;///m; // Random vector.

    // 距离函数 -- 菱形和偏移结节。
    float d = di(p - dirV),
    c = length(p - dirV * .2) - .2;
    // 将结节添加到对角线的随机一侧。
    if (rD.x < 0.) {
        if (c < d) ip -= dirV * 2.;
    }
    return vec3(min(d, c), ip + dirV);
}

float num = 30.0;
void main() {
    vec2 pos = (textureCoordinate - center);
    if (ratio > 1.0) {
        pos.x *= ratio;
    } else {
        pos.y /= ratio;
    }
    pos *= num;
    vec3 d = jigsaw(pos);
    //    vec2 colorpos = floor(vec2(d.yz)) + center;
    vec2 colorpos = vec2(d.yz);
    colorpos /= num;
    if (ratio > 1.0) {
        colorpos.x /= ratio;
    } else {
        colorpos.y *= ratio;
    }
    colorpos += center;

    // Some ID-based coloring.
    vec4 color = texture2D(inputImageTexture, colorpos);
//    gl_FragColor=color;
    //    中间的间隔黑线
    vec3 col = mix(color.rgb, vec3(0.), smoothstep(0.0, 0.01, d.x));
    gl_FragColor = vec4(col, 1.0);
}