//https://www.shadertoy.com/view/WltSWM
precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;


void main()
{
    vec2 center = vec2(0.5);
    vec2 usepos = textureCoordinate - center;
    vec2 mouse = vec2(progress / 200.0);
    if (ratio > 1.0) {
        usepos.x *= ratio;
    } else {
        usepos.y /= ratio;
    }

    vec2 glass_offset = sin(usepos * 100.0 - mouse) * 10.0;
    glass_offset /= vec2(720.0);
    vec2 glass_uv = usepos + glass_offset;
    if (ratio > 1.0) {
        glass_uv.x /= ratio;
    } else {
        glass_uv.y *= ratio;
    }
    glass_uv += center;
    gl_FragColor = texture2D(inputImageTexture, glass_uv);
}

